#!/bin/sh


# Test cases for Stack additions

printf "\n##################################################################"
printf "\n#######  RUNNING STACK TEST CASES - EXPECTED RESULT IN ()  #######"
printf "\n##################################################################"
printf "\n\n"
printf ">> Testing stack-error01.jan... (error: pop from empty)\n"
./JC stack-error01
cat stack-error01.in | spim stack-error01.as | grep '\(ERROR: \)'
printf ">> Testing stack-error02.jan... (error: pop to non-zero)\n"
./JC stack-error02
cat stack-error02.in | spim stack-error02.as | grep '\(ERROR: \)'
printf ">> Testing stack-error03.jan... (error: non-empty stack)\n"
./JC stack-error03
cat stack-error03.in | spim stack-error03.as | grep '\(ERROR: \)'
printf ">> Testing stack-error04.jan... (error: swap with < 2)\n"
./JC stack-error04
cat stack-error04.in | spim stack-error04.as | grep '\(ERROR: \)'
printf ">> Testing stack-error05.jan... (type error)\n"
./JC stack-error05
printf ">> Testing stack-error06.jan... (type error)\n"
./JC stack-error06
printf ">> Testing stack-empty.jan... (empty)\n"
./JC stack-empty
cat stack-empty.in | spim stack-empty.as | diff -I '^\(Loaded\|SPIM\)' - stack-empty.out
printf ">> Testing stack-fib.jan... (empty)\n"
./JC stack-fib
cat stack-fib.in | spim stack-fib.as | diff -I '^\(Loaded\|SPIM\)' - stack-fib.out
printf ">> Testing stack-reverse.jan... (empty)\n"
./JC stack-reverse
cat stack-reverse.in | spim stack-reverse.as | diff -I '^\(Loaded\|SPIM\)' - stack-reverse.out
printf ">> Testing stack-swap.jan... (empty)\n"
./JC stack-swap
cat stack-swap.in | spim stack-swap.as | diff -I '^\(Loaded\|SPIM\)' - stack-swap.out
printf ">> Testing stack-uncall.jan... (empty)\n"
./JC stack-uncall
cat stack-uncall.in | spim stack-uncall.as | diff -I '^\(Loaded\|SPIM\)' - stack-uncall.out
printf "\n"

# Exit shell script
exit 0
